/*
 *  file    : main.c
 *  auther  : Shinya Esu
 *  comment : Ȥ󤦤ä
 *  version : $Id$
 */


#include <gtk/gtk.h>
#include <gdk/gdkx.h>
#include <time.h>

#include "toko_clock.h"
#include "toko_types.h"
#include "toko_mascot.h"
#include "clock.h"
#include "toko.h"
#include "configfile.h"

#define XSIZE 193
#define YSIZE 193
#define TIMEOUT 100

/*
 * ʸ
 */
typSprite sprite_clock[] =  {
	{ clock_xpm, NULL, NULL, 0 }, 
	{ NULL, NULL, NULL, 0 }
};

/*
 * Ȥ
 */
typSprite sprite_toko[] =  {
	{ toko0_xpm, NULL, NULL, 60 }, 
	{ toko1_xpm, NULL, NULL, 0 }, 
	{ toko2_xpm, NULL, NULL, 0 }, 
	{ toko1_xpm, NULL, NULL, 0 }, 
	{ NULL, NULL, NULL, 0 }
};

/*
 * ޥå
 */
typMascot mascot_clock;
typMascot mascot_toko;

/* ֥Хåե */
static GdkPixmap *pixmap = NULL;
static GdkBitmap *pixmap_mask = NULL;
static gint mask_x,mask_y;

/* ᥤ󥦥ɥ */
static GtkWidget *window = NULL;

/* Ƽ */
Config cfg;

/* ɥưΤΥƥݥ */
static gint window_x = 0;
static gint window_y = 0;
static gboolean window_moving = FALSE;

/*
 * եɤ߹
 */
void read_config(void)
{
	ConfigFile *cfgfile;
	gchar *filename;

	memset(&cfg, 0, sizeof (Config));
	cfg.window_x = 0;
	cfg.window_y = 0;

	filename = g_strconcat(g_get_home_dir(), "/.tokoclockrc", NULL);
	cfgfile = xmms_cfg_open_file(filename);
	if (cfgfile)
	{
		xmms_cfg_read_int(cfgfile, "tokoclock","window_x",&cfg.window_x);
		xmms_cfg_read_int(cfgfile, "tokoclock","window_y",&cfg.window_y);
		xmms_cfg_free(cfgfile);
	}
	g_free(filename);
}

/*
 * եν񤭹
 */
void write_config(void)
{
	ConfigFile *cfgfile;
	gchar *filename;

	filename = g_strconcat(g_get_home_dir(), "/.tokoclockrc", NULL);
	cfgfile = xmms_cfg_open_file(filename);
	if (!cfgfile)
		cfgfile = xmms_cfg_new();
	xmms_cfg_write_int(cfgfile, "tokoclock", "window_x", cfg.window_x);
	xmms_cfg_write_int(cfgfile, "tokoclock", "window_y", cfg.window_y);
	xmms_cfg_write_file(cfgfile, filename);
	xmms_cfg_free(cfgfile);
	g_free(filename);
}

/*
 * 
 */
void window_init(void)
{
	read_config();
}

/*
 * λ
 */
void window_quit(void)
{
	write_config();
	gtk_main_quit();
}

/*
 * 
 */
gint Repaint(gpointer data)
{
	GtkWidget*	drawing_area = (GtkWidget *) data;
	GdkRectangle  update_rect;
	static offset = 0;
	gint nTop;

	if (!CheckRepaintClock() && !CheckRepaintMascot(&mascot_toko)) {
		 return TRUE;
	}

	/* ʸפκ */
	DrawMascot(drawing_area, pixmap, &mascot_clock);

	/* ɥΥޥ */
	pixmap_mask = mascot_clock.sprites[mascot_clock.seq].mask;  
	mask_x = mascot_clock.x;
	mask_y = mascot_clock.y;

	/* ޥåȤκ */
	DrawMascot(drawing_area, pixmap, &mascot_toko);

	/* ˤκ */
	RepaintClock(data, pixmap);

	/*  */
	update_rect.x = 0;
	update_rect.y = 0;
	update_rect.width = drawing_area->allocation.width;
	update_rect.height = drawing_area->allocation.height;
	gtk_widget_draw(drawing_area, &update_rect);

}

/*
 * drawing area  configureν
 */
static gint dw_configure(GtkWidget *widget, GdkEventConfigure *event)
{
	if (pixmap) {
		gdk_pixmap_unref(pixmap);
	} 

	pixmap = gdk_pixmap_new(widget->window,
				widget->allocation.width,
				widget->allocation.height,
				-1);
	return TRUE;
}

/*
 * drawing area  exposeν
 */
gint dw_expose(GtkWidget *widget, GdkEventExpose *event)
{
	gdk_draw_pixmap(widget->window,
		  widget->style->fg_gc[GTK_WIDGET_STATE (widget)],
		  pixmap,
		  event->area.x, event->area.y,
		  event->area.x, event->area.y,
		  event->area.width, event->area.height);
	gtk_widget_shape_combine_mask( window, pixmap_mask, mask_x, mask_y ); 
	return FALSE;
}


/*
 * ᥤ󥦥ɥΰưν
 */
void window_motion(GtkWidget * widget, GdkEventMotion * event)
{   
	if (window_moving){
		gint mx, my, newx, newy;
		gint sw, sh, w, h, sd;
		gint mwx, mwy, mww, mwh;
		GdkModifierType modmask;
						 
		gdk_window_get_pointer(NULL, &mx, &my, &modmask);
		newx = mx - window_x;
		newy = my - window_y;
		cfg.window_x = newx;
		cfg.window_y = newy;
		gdk_window_move(window->window, newx, newy);
	}
}   


/*
 * ᥤ󥦥ɥΥޥν
 */
void window_press(GtkWidget * widget, GdkEventButton * event)
{
	if (event->button == 1)
	{
		window_moving = TRUE;
		window_x = event->x;
		window_y = event->y;
		gdk_pointer_grab(window->window, 
			FALSE, GDK_BUTTON_MOTION_MASK | GDK_BUTTON_RELEASE_MASK,
			GDK_NONE, GDK_NONE, GDK_CURRENT_TIME);
		gdk_flush();
	}
	if (event->button == 3)
	{
		window_quit();
	}
}

/*
 * ᥤ󥦥ɥΥޥ꡼ν
 */
void window_release(GtkWidget * widget, GdkEventMotion * event)
{
	if (window_moving){
		window_moving = FALSE;
	}
	gdk_pointer_ungrab(GDK_CURRENT_TIME);
	gdk_flush();
}

/*
 * ᥤ󥦥ɥΥޥեν
 */
void window_focus_in(GtkWidget * widget, GdkEventMotion * event)
{
	gdk_flush();
}

/*
 * ᥤ󥦥ɥΥޥեȤν
 */
void window_focus_out(GtkWidget * widget, GdkEventMotion * event)
{
	gdk_pointer_ungrab(GDK_CURRENT_TIME);
	gdk_flush();
}

/*
 * main
 *
 * Program begins here.
 */ 
int main (int argc, char *argv[])
{
	GtkWidget *drawing_area;
	GtkWidget *vbox;

	gtk_init(&argc, &argv);
	window_init();

	/* ᥤ󥦥ɥ */
	window = gtk_window_new(GTK_WINDOW_TOPLEVEL);
	gtk_widget_set_app_paintable(window, TRUE);

	gtk_window_set_title(GTK_WINDOW(window), "TOKOCLOCK");
	gtk_window_set_policy(GTK_WINDOW(window), FALSE, FALSE, TRUE);
	gtk_window_set_wmclass(GTK_WINDOW(window), "TOKOCLOCK", "TOKOCLOCK");
	gtk_widget_set_events(GTK_WIDGET (window), 
		GDK_FOCUS_CHANGE_MASK | 
		GDK_BUTTON_MOTION_MASK | 
		GDK_BUTTON_RELEASE_MASK | 
		GDK_BUTTON_PRESS_MASK | 
		GDK_EXPOSURE_MASK);
	gtk_widget_realize(window);
	gtk_widget_set_usize(window, XSIZE, YSIZE);
	gdk_window_set_decorations(window->window, 0);

	vbox = gtk_hbox_new(FALSE, 0);
	gtk_container_add(GTK_CONTAINER (window), vbox);
	gtk_widget_show(vbox);

	gtk_signal_connect(GTK_OBJECT (window), "destroy",
				GTK_SIGNAL_FUNC (window_quit), NULL);
	gtk_signal_connect(GTK_OBJECT (window), "motion_notify_event",
				GTK_SIGNAL_FUNC (window_motion), NULL);
	gtk_signal_connect(GTK_OBJECT (window), "button_press_event",
				GTK_SIGNAL_FUNC (window_press), NULL);
	gtk_signal_connect(GTK_OBJECT (window), "button_release_event",
				GTK_SIGNAL_FUNC (window_release), NULL);
	gtk_signal_connect(GTK_OBJECT (window), "focus_in_event",
				GTK_SIGNAL_FUNC (window_focus_in), NULL);
	gtk_signal_connect(GTK_OBJECT (window), "focus_out_event",
				GTK_SIGNAL_FUNC (window_focus_out), NULL);

	/* drawing area  */
	drawing_area = gtk_drawing_area_new();
	gtk_drawing_area_size(GTK_DRAWING_AREA (drawing_area), XSIZE, YSIZE);
	gtk_box_pack_start(GTK_BOX (vbox), drawing_area, TRUE, TRUE, 0);

	gtk_widget_show(drawing_area);

	gtk_signal_connect(GTK_OBJECT (drawing_area), "expose_event",
				GTK_SIGNAL_FUNC (dw_expose), NULL);
	gtk_signal_connect(GTK_OBJECT(drawing_area),"configure_event",
				GTK_SIGNAL_FUNC (dw_configure), NULL);

	gtk_widget_set_uposition(window, cfg.window_x, cfg.window_y);
	gtk_widget_show(window);
	gdk_window_move(window->window, cfg.window_x, cfg.window_y);
	gdk_flush();


	/* 롼򥿥ޤ˥å */
	gtk_timeout_add(TIMEOUT, Repaint, drawing_area);

	/* ޥåȤɤ߹ */
	LoadPixmaps(window, &mascot_clock, sprite_clock);
	LoadPixmaps(window, &mascot_toko, sprite_toko);

	mascot_clock.x = 0;
	mascot_clock.y = 0;
	mascot_toko.x = (XSIZE - mascot_toko.width) / 2;
	mascot_toko.y = (YSIZE - mascot_toko.height) / 2;

	gtk_main();

	return 0;
}



